## org.biojava.bio.gui.sequence
Class FeatureBlockSequenceRenderer

    java.lang.Object
      org.biojava.utils.AbstractChangeable
          org.biojava.bio.gui.sequence.FeatureBlockSequenceRenderer

All Implemented Interfaces:
  SequenceRenderer, Changeable

    public class FeatureBlockSequenceRenderer

extends AbstractChangeable
implements SequenceRenderer

`FeatureBlockSequenceRenderer` forms a bridge between `Sequence` rendering and `Feature` rendering. It is a `SequenceRenderer` which iterates through a `Sequence`'s `Feature`s and makes method calls on a `FeatureRenderer`.

Author:
  Matthew Pocock, Keith James, Thomas Down

Nested Class Summary

Nested classes/interfaces inherited from interface org.biojava.bio.gui.sequence.SequenceRenderer
`SequenceRenderer.RendererForwarder`

Field Summary
`static ChangeType` `FEATURE_COLLAPSING`
`static ChangeType` `FEATURE_RENDERER`

Constructor Summary
`FeatureBlockSequenceRenderer()` Creates a new `FeatureBlockSequenceRenderer` which uses a `BasicFeatureRenderer` as its renderer.
`FeatureBlockSequenceRenderer(FeatureRenderer fRend)` Creates a new `FeatureBlockSequenceRenderer` which uses the specified `FeatureRenderer`.

Method Summary
`protected ChangeSupport` `getChangeSupport(ChangeType ct)` Called to retrieve the ChangeSupport for this object.
`boolean` `getCollapsing()` Returns `true` if this class collapses to zero depth when there are no visible features.
`double` `getDepth(SequenceRenderContext src)` Retrieve the depth of this renderer when rendering src.
`FeatureRenderer` `getFeatureRenderer()` `getFeatureRenderer` returns the currently active renderer.
`double` `getMinimumLeader(SequenceRenderContext src)` Retrieve the minimum leading distance for this renderer when rendering src.
`double` `getMinimumTrailer(SequenceRenderContext src)` Retrieve the minimum trailing distance for this renderer when rendering src.
`void` `paint(Graphics2D g, SequenceRenderContext src)` Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.
`SequenceViewerEvent` `processMouseEvent(SequenceRenderContext src, MouseEvent me, List path)` Produce a SequenceViewerEvent in response to a mouse gesture.
`void` `setCollapsing(boolean b)` Specifies if the renderer should collapse to zero depth when no features are visible (default `true`).
`void` `setFeatureRenderer(FeatureRenderer renderer)` `setFeatureRenderer` sets the renderer to be used.

Methods inherited from class org.biojava.utils.AbstractChangeable
`addChangeListener, addChangeListener, generateChangeSupport, hasListeners, hasListeners, isUnchanging, removeChangeListener, removeChangeListener`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### FEATURE_RENDERER

    public static ChangeType FEATURE_RENDERER

### FEATURE_COLLAPSING

    public static ChangeType FEATURE_COLLAPSING

Constructor Detail

### FeatureBlockSequenceRenderer

    public FeatureBlockSequenceRenderer()

  Creates a new `FeatureBlockSequenceRenderer` which uses a `BasicFeatureRenderer` as its renderer.

### FeatureBlockSequenceRenderer

    public FeatureBlockSequenceRenderer(FeatureRenderer fRend)

  Creates a new `FeatureBlockSequenceRenderer` which uses the specified `FeatureRenderer`.

  Parameters:
    `fRend` - a `FeatureRenderer`.

Method Detail

### getChangeSupport

    protected ChangeSupport getChangeSupport(ChangeType ct)

  Description copied from class: `AbstractChangeable`
  Called to retrieve the ChangeSupport for this object.

  Your implementation of this method should have the following structure: ``

       ChangeSupport cs = super.getChangeSupport(ct);

       if(someForwarder == null && ct.isMatching(SomeInterface.SomeChangeType)) {
         someForwarder = new ChangeForwarder(...

         this.stateVariable.addChangeListener(someForwarder, VariableInterface.AChange);
       }

       return cs;

  It is usual for the forwarding listeners (someForwarder in this example) to be transient and lazily instantiated. Be sure to register & unregister the forwarder in the code that does the ChangeEvent handling in setter methods.

  Overrides:
    `getChangeSupport` in class `AbstractChangeable`

### getFeatureRenderer

    public FeatureRenderer getFeatureRenderer()

  `getFeatureRenderer` returns the currently active renderer.

  Returns:
    a `FeatureRenderer`.

### setFeatureRenderer

    public void setFeatureRenderer(FeatureRenderer renderer)
                            throws ChangeVetoException

  `setFeatureRenderer` sets the renderer to be used.

  Parameters:
    `renderer` - a `FeatureRenderer`.
  Throws:
    `ChangeVetoException` - if the renderer can not be changed.

### setCollapsing

    public void setCollapsing(boolean b)
                       throws ChangeVetoException

  Specifies if the renderer should collapse to zero depth when no features are visible (default `true`).

  Throws:
    `ChangeVetoException`
  Since:
    1.3

### getCollapsing

    public boolean getCollapsing()

  Returns `true` if this class collapses to zero depth when there are no visible features.

  Since:
    1.3

### getDepth

    public double getDepth(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the depth of this renderer when rendering src.

  The depth may vary between sequence panels - for example based upon sequence length. Each line of information in the SequenceRendererContext only renders a region of the sequence. The depth for one complete line may be different from that for another due to the sequence having more or less information in that region to show. For example, a feature renderer implementation may chose to collapse down to a depth of zero pixels if there are no features to render within a region.

  Specified by:
    `getDepth` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the depth of the renderer for that sequence panel

### getMinimumLeader

    public double getMinimumLeader(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the minimum leading distance for this renderer when rendering src.

  The leading distance may vary between sequence panels - for example based upon sequence length.

  Specified by:
    `getMinimumLeader` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the leading distance of the renderer for that sequence panel

### getMinimumTrailer

    public double getMinimumTrailer(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the minimum trailing distance for this renderer when rendering src.

  The trailing distance may vary between sequence panels - for example based upon sequence length.

  Specified by:
    `getMinimumTrailer` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the trailing distance of the renderer for that sequence panel

### paint

    public void paint(Graphics2D g,
                      SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.

  Specified by:
    `paint` in interface `SequenceRenderer`
  Parameters:
    `g` - the Graphics2D to render to
    `src` - the SequenceRenderContext that encapsulates the information to render

### processMouseEvent

    public SequenceViewerEvent processMouseEvent(SequenceRenderContext src,
                                                 MouseEvent me,
                                                 List path)

  Description copied from interface: `SequenceRenderer`
  Produce a SequenceViewerEvent in response to a mouse gesture.

  A SequenceRenderer that performs any form of coordinate remapping should ensure that it appropriately transforms the mouse event. However, in the SequenceViewerEvent returned, the MouseEvent should be in untransformed coordinates.

  The SequenceRenderer implementation should append itself to the path list before constructing the SequenceViewerEvent.

  Specified by:
    `processMouseEvent` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext currently in scope
    `me` - a MouseEvent that caused this request
    `path` - the List of SequenceRenderer instances passed through so far
  Returns:
    a SequenceViewerEvent encapsulating the mouse gesture